const cursor = document.querySelector('.cursor');

document.addEventListener('mousemove', e => {
    cursor.setAttribute('style', 'top:'+(e.pageY - 20)+"px; left:"+(e.pageX - 20)+"px;")
})

document.addEventListener('click', ()=>{
    cursor.classList.add('expand');

    setTimeout(()=>{
        cursor.classList.remove("expand");
    }, 500);
})




var called = false;
		var body = document.getElementsByTagName('body')[0];

		window.requestAnimFrame =
		window.requestAnimationFrame || 
		window.webkitRequestAnimationFrame || 
		window.mozRequestAnimationFrame || 
		window.ORequestAnimationFrame || 
		window.msRequestAnimationFrame || 
		
		function(callback) { 
		  setTimeout(callback, 1000 / 60);
		};



		var ctxA = new (window.AudioContext || window.webkitAudioContext)(),
			fileReader,
			spectrums,
			gainNode,
			source,
			audio,
			colour,
			analyser,
      cWidth = 300;

		var canvas = {

			data : {
				'classe' : ['canvas__left', 'canvas__right'],
				'width' : cWidth,
				'height' : window.innerHeight
			},

			init : function(){
				that = this.data;
				for(var i = 0; i < that.classe.length; i++){
					var c = document.createElement("canvas");
					c.width = that.width;
					c.height = that.height;
					c.setAttribute("class", that.classe[i]);
					body.insertBefore(c, body.childNodes[0]);
				}
			}

		};

		var shade = {

			data : {
				x : 0,
				y : 0,
				max : 255,
		      	min : 150,		      	
			},

			init : function(){     	
		      	this.color();
		      	this.update();
		    },

		    draw : function(x, y){
		    	
		    	var rand = Math.floor(Math.random() * cs[0].width); //partie à modifier
		    	for(var i = 0; i <= 1; i++){
		    		ctx[i].beginPath();
			    	ctx[i].moveTo(0,y);
					ctx[i].lineTo(0, y+2);
	    			ctx[i].lineTo(x, y+1);
			    	ctx[i].fill();

			    	ctx[i].closePath();
		    	}
		    },

		    update : function(step){
		    	that = shade.data;

		    	that.y = 0;
		    	for(var i = 0; i <= 1; i++){
				   	ctx[i].clearRect(0,0, cs[0].width, cs[0].height);
				}

				music.create();
		    	
		    	requestAnimFrame(shade.update);
		    },

		    color : function(){
		    	var r = [false, Math.floor(Math.random() * shade.data.max)],
		      	g = [false, Math.floor(Math.random() * shade.data.max)],
		      	b = [false, Math.floor(Math.random() * shade.data.max)];
		      	setInterval(function(){
		      		
		      		if(r[1] === shade.data.max) r[0] = true;
		      		if(r[1] === shade.data.min) r[0] = false;
		      		if(r[0] === false) r[1]++;
		      		if(r[0] === true) r[1]--;

		      		if(g[1] === shade.data.max) g[0] = true;
		      		if(g[1] === shade.data.min) g[0] = false;
		      		if(g[0] === false) g[1]++;
		      		if(g[0] === true) g[1]--;

		      		if(b[1] === shade.data.max) b[0] = true;
		      		if(b[1] === shade.data.min) b[0] = false;
		      		if(b[0] === false) b[1]++;
		      		if(b[0] === true) b[1]--;

		      		for(var i = 0; i <= 1; i++){
		      			colour = 'rgba('+r[1]+','+g[1]+','+b[1]+',0.8)';
		    			ctx[i].fillStyle = colour;
		    			document.getElementsByClassName('label')[0].style.setProperty('border-color', colour,'');
		    		}
		    	},100);
		    }
		};

		canvas.init();
		var cs = document.querySelectorAll('canvas');
		var ctx2 = ctx = [cs[0].getContext("2d", {'alpha' : true}), cs[1].getContext("2d", {'alpha' : true})];


		var music = {

			init : function(){

				analyser = ctxA.createAnalyser();
				analyser.fftSize = 2048;
				analyser.minDecibels = -256;
				analyser.maxDecibels = 256;
				analyser.smoothingTimeConstant = 0.75;
				fileReader.onload = function(){
						
					ctxA.decodeAudioData(fileReader.result, function(buffer){
						if(source){
							source.stop();
						}

						source = ctxA.createBufferSource();
						source.buffer = buffer;

						source.loop = true;
						source.connect(analyser);
						

						gainNode = ctxA.createGain();
						source.connect(gainNode);

						gainNode.connect(ctxA.destination);

						source.start(0);

						spectrums = new Uint8Array(analyser.frequencyBinCount);
						analyser.getByteTimeDomainData(spectrums);

						
					});	
				
				};
			
				this.update();
				
			},

			create : function(){
				for(var i = 0; i < cs[0].height; i++){
			    	
			    	if(source){
			    		var x = spectrums[i] / 1.5;
						shade.draw(x, that.y);
						document.getElementsByClassName('label')[0].style.setProperty('box-shadow', '0 0 '+ x+'px '+ colour,'');
					}
					if(!source){
						shade.draw(2, that.y);
						document.getElementsByClassName('label')[0].style.setProperty('border-width', '1px','');
					}
			    	

	    			that.y += 2;
			    }
			},

			update : function(){
				
				spectrums = new Uint8Array(analyser.frequencyBinCount);
				analyser.getByteTimeDomainData(spectrums);
				requestAnimFrame(music.update);
			}
		};

		function input(){
			var input = document.createElement("input");
			var label = document.createElement("label");
			label.setAttribute("for", "input");
			label.setAttribute("class", "label");
			label.innerText = "Choisis un fichier audio(.mp3)";
			input.name = input.type = "file";
			input.setAttribute("id","input");
			body.insertBefore(input, body.childNodes[0]);
			body.insertBefore(label, body.childNodes[0]);
		}

		input();
		shade.init();
		document.getElementById("input").addEventListener("change", function(e){
			document.getElementsByClassName('label')[0].innerText = e.target.files[0].name;
			fileReader = new FileReader();
			fileReader.readAsArrayBuffer(e.target.files[0]);
			music.init();
			
		}.bind(this), false);

var a = document.createElement("a");
a.innerText = "Made by Robin Metais";
a.href="https://www.youtube.com/watch?v=dQw4w9WgXcQ"
a.title = "";
a.target="";
body.insertBefore(a, body.childNodes[0]);